                               ;    PIC-
                       
;    :
; 
; 1.       (1-24 )
; 2.            
; 3.           15 
; 4.    :
;    -  
;    -  
;    -   
;    -        ( 30 )
;    -   ( 5 )
;    -   
;    -    
; 5.  -
; 6.    
; 7.  
        ;   - 4
	processor	16F84 
	Include	<p16f84.inc>
 __CONFIG  _CP_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC ;  
 errorlevel      -302
        CBLOCK  0CH
        T_C             ;    
	_N              ;    
        O_BYTE          ;    
        I_BYTE          ;     
        LOOP3		;              
        LOOP2           ;
        LOOP1         	;  
        TEMP		;
        r10stmp         ;      
	KONTROL         ;   
        M_SIG           ;      
        r4stop          
        M_STOP     ;   
        r10s       ;    10       EEPROM 
        r3s        ;    3      EEPROM
        minP       ;    30   .
        vibor      ;    
        vibsig     ;    
        r5s        ;    5  
        TIME       ;     1-24 
        rt1        ;     
        rt2        ;     
        attempt    ;   
        r6s        ;    6      
        r15m1      ;     
        r15m2      ;     
        THM        ;   
        r4sne      ;       
        SEL        ;      
        r60s       ;    60
        r15s
        HOURS
        FLAG1	   ; 1    
                   ; 7-  
                   ; 6-
	           ; 5- 
                   ; 4- 
                   ; 3- 
                   ; 2- 1
                   ; 1- 2
                   ; 0-  
        FLAG2      ; 2   
                   ; 7-  1
                   ; 6- 
                   ; 5-ON
                   ; 4- 3
                   ; 3- 
                   ; 2-  
                   ; 1- 
                   ; 0- -
        FLAG3      ; 3   
                   ; 7- -
                   ; 6-  
                   ; 5-  
                   ; 4-  -1
                   ; 3-   
                   ; 2-  
                   ; 1-  
                   ; 0-   
        FLAG4      ; 4   
                   ; 7-  
        
        ENDC
Pr     equ	h'03'
torm   equ	h'02'
door   equ	h'01'
alarm  equ	h'00'
hand   equ	h'06'
kanal  equ	h'05'
key    equ	h'04'
nakal  equ	h'07'
HA     equ	h'02'
ST     equ	h'01'
ZG     equ	h'03'
GBR    equ	h'00'
ON     equ      h'05'
DATA_PIN    equ     h'07'  ;     
                  
	Org	H'0000'	   ;     
	GOTO	MAIN        ;  
;***************************************************************************
MAIN:
        MOVLW	B'11111111'	;    
	MOVWF	PORTB           ;        
        MOVLW	B'00010000'	;    
	MOVWF	PORTA           ;
            	  ;     
	BSF	STATUS, RP0	;   1  
	MOVLW	B'00010000'	; RA<0:3> - , RA<4> - 
	MOVWF	TRISA		;    W  TRISA
	MOVLW	B'11111111'	;   RB - 
	MOVWF	TRISB		;    W  TRISB
	MOVLW	B'00111000'	;   WDT, ..-.,R-.
	MOVWF	OPTION_REG	;      OPTION
        BCF	STATUS, RP0	;   0  
        CLRF	INTCON		;   
        CLRF    FLAG1           ;   FLAG1
        CLRF    FLAG2           ;   FLAG2
        CLRF    FLAG3           ;   FLAG3
        CLRF    FLAG4           ;   FLAG4
        CLRF    vibor 
        CLRF    vibsig          ;  
        CLRF    TIME
        CLRF    SEL
        CLRF    M_STOP
        MOVLW	D'25'     	;    
	MOVWF	r10s            ;   r10s 
        MOVLW	D'10'       	;    
	MOVWF	r3s             ;   r3s
        MOVLW	D'12'   	;    
	MOVWF	r5s             ;   r5s
        MOVLW	D'71'   	;    
	MOVWF	minP            ;   minP
        MOVLW	D'140'     	;    
	MOVWF	r15m1           ;   r15m1
        MOVLW	D'15'     	;    
	MOVWF	r15m2           ;   r15m2
        MOVLW	D'200'     	;    
	MOVWF	rt1             ;   rt1 
        MOVLW	D'60'     	;    
	MOVWF	rt2             ;   rt2
        MOVLW	D'22'     	;    
	MOVWF	r6s             ;   r6s
        MOVLW	D'11'            ;    
	MOVWF	r4sne           ;   r4sne
        MOVLW   D'97'           ;   
        MOVWF   r60s            ;   r60s
        MOVLW   h'03'           ;   
        MOVWF   attempt         ;   attempt 
        MOVLW   D'16'           ;   
        MOVWF   r4stop          ;   r4stop 
        movlw   D'26'           ;   
        movwf   r10stmp         ;   r10stmp  
        movlw   D'29'           ;   
        movwf   r15s            ;   r15s
        

                      ;     EEPROM
;**********************************************************************************
       clrw                     ;   h'00'
       CALL   READ_M 
       movwf  vibor             ;    vibor
;**********************************************************************************
                          ;    EEPROM
;***************************************************************************************
MAIN1:
       movlw  h'01'             ;   h'01'
       CALL   READ_M 
       movwf  KONTROL           ;    
       
CYCLE:                    
        	         ;    
        CLRF    THM             ;  
        bcf     INTCON, T0IF    ;    TMR0
        clrf	TMR0		;  TMR0,      
	MOVLW	h'fb'           ;  FB,    
        MOVWF   TMR0            ;  3 a (360 /)
        call    DELAY_LONG      ;  0,25(    )
        BTFSS   INTCON, T0IF    ;   TMR0 ?
        GOTO    m0              ; ,   
        comf    THM, F          ; ,    
                       ;  
;----------------------------------------------------------------------------------
m0:        
        BTFSS   PORTB, torm     ;   ?        	
        GOTO    m2              ; ,   
        CALL    Delay_z         ; ,    
        BTFSS   PORTB, torm     ;     ? 
        GOTO    m2              ; ,   
        BTFSC   PORTB, key      ;  ?
        GOTO    m1              ; ,   
        CALL    Delay_z         ; ,    
        BTFSC   PORTB, key      ;    ?
        GOTO    m1              ; ,   
        BTFSC   SEL, 7          ;  SEL ?
        bsf     PORTA, HA       ; ,  
        GOTO    m2              ; ,   
m1:
        bcf     PORTA, HA       ;   
                        ;  \. 
;-----------------------------------------------------------------------------
m2:         
        BTFSS   PORTB, hand    ;  ?
        GOTO    m4             ; ,   
        BTFSC   PORTB, door   
        GOTO    m4
        BTFSC   PORTB, torm
        GOTO    m4             ;  ,
        BTFSS   THM, 7         ;  , 
        GOTO    m4             ;   
        BTFSC   PORTB, key     ;  ?
        GOTO    m3             ; ,   
        CALL    Delay_z        ;    
        BTFSC   PORTB, key     ;  ?
        GOTO    m3             ; ,   
        bsf     FLAG2, ON      ; ,   ON    
        bsf     PORTA, HA      ;  
        GOTO    m4             ;   
m3:
        bcf     PORTA, HA      ;  
        BTFSS   FLAG2, ON      ;  ON  FLAG2 ?
        GOTO    m4             ; ,   
        COMF    SEL, F         ;   SEL
        bcf     FLAG2, ON      ;   ON 
                       ;    
;------------------------------------------------------------------------------------
m4:
        BTFSC   THM, 7         ;  ?
        GOTO    m6             ; ,   
        BTFSC   PORTB, hand    ;  ?
        GOTO    m6             ; ,   
        BTFSC   PORTB, door       
        GOTO    m6
        BTFSS   PORTB, Pr      ;   , 
        GOTO    m6
        BTFSC   PORTB, torm    ;  ,
        GOTO    m6             ;    
        BTFSC   vibor, 0        ;  ?
        GOTO    m76             ; ,   
        BTFSS   FLAG2, 4        ;  3 ?
        GOTO    m6             ; ,   
m76:
        BTFSS   SEL, 7         ;  SEL ? 
        GOTO    m6             ; ,   
        BTFSC   PORTB, key     ;  ?
        GOTO    m7             ; ,    
        CALL    Delay_z        ;    
        BTFSC   PORTB, key     ;    ?
        GOTO    m7             ; ,   
        bcf     FLAG2, 7       ;   1
        bsf     FLAG2, 6       ;     
        bsf     PORTA, HA      ;  
        GOTO    m6             ;   
m7:
        bcf     PORTA, HA      ;  
        BTFSS   FLAG2, 6       ;    ?
        GOTO    m6             ; ,   
        MOVLW   D'24'
        MOVWF   HOURS
        CLRF    TIME           ; ,  TIME
        call    DELAY_LONG
        call    DELAY_LONG
        call    DELAY_LONG
        call    DELAY_LONG
m74:
        bsf     PORTA, HA 
        INCF    TIME, F        ;  TIME
        call    DELAY_LONG
        call    DELAY_LONG
        bcf     PORTA, HA       ;  
        call    DELAY_LONG
        call    DELAY_LONG
        call    DELAY_LONG
        DECFSZ  HOURS, F
        GOTO    m5
m73: 
        bcf     FLAG2, 6        ;    
        bsf     FLAG2, 7        ;    1
        MOVLW	D'200'     	;    
	MOVWF	rt1             ;   rt1 
        MOVLW	D'60'     	;   
        MOVWF	rt2             ;   rt2 
m8:
        call    DELAY_LONG
        call    DELAY_LONG
        call    DELAY_LONG
        call    DELAY_LONG
        call    DELAY_LONG
        bsf     PORTA, HA
        movlw   .12
        MOVWF   LOOP3
t14:
        CALL    DELAY_LONG
        DECFSZ  LOOP3, F       ;  3 
        GOTO    t14
        bcf     PORTA, HA      ;  
        GOTO    m6             ;    
m5:
        BTFSC   THM, 7         ;  ?
        GOTO    m73             ; ,   
        BTFSC   PORTB, hand    ;  ?
        GOTO    m73             ; ,   
        BTFSC   PORTB, door       
        GOTO    m73
        BTFSS   PORTB, Pr      ;   , 
        GOTO    m73
        BTFSC   PORTB, torm    ;  ,
        GOTO    m73             ;    
        GOTO    m74

                    ;    
;----------------------------------------------------------------------------
m6:
        BTFSC   FLAG2, 4       ;   3 ? 
        GOTO    m56            ; ,          
        BTFSC   FLAG1, 1       ;   2 ?  
        GOTO    m9             ; ,          
        BTFSC   FLAG1, 2       ;   1 ?  
        GOTO    m12            ; ,   
        BTFSS   THM, 7         ;  ,      ;
        GOTO    m10            ;  ,         ; 
        BTFSS   PORTB, hand    ;  ,           ;
        GOTO    m10            ;     ; 
        BTFSC   PORTB, door                               ; 1 
        GOTO    m10                                       ;
        BTFSS   PORTB, torm                               ; 
        GOTO    m10            ; ,       ; 
        bsf     FLAG1, 2       ;    1
        GOTO    m10            ;   
m12:
        BTFSC   PORTB, key     ;  ?
        GOTO    m13            ; ,    
        CALL    Delay_z        ;    
        BTFSC   PORTB, key     ;    ?
        GOTO    m13            ; ,   
        bsf     PORTA, HA      ;  
        bsf     FLAG3, 3       ;    
        GOTO    m10
m11:
        MOVLW	D'11'           ;    
	MOVWF	r4sne          ;   r4sne 
        bsf     FLAG1, 1       ;   2
        bcf     FLAG3, 3       ;    
        GOTO    m10            ;    
m9:
        BTFSS   THM, 7         ;  ,       ;
        GOTO    m57            ;  ,           ;
        BTFSC   PORTB, hand    ;  ,            ; 
        GOTO    m57            ;      ; 2 
        BTFSC   PORTB, door                                ;
        GOTO    m57                                        ;
        BTFSS   PORTB, torm                                ;
        GOTO    m57            ; ,        ;
        bsf     PORTA, HA      ;  
        movlw   .12
        MOVWF   LOOP3
t23:
        CALL    DELAY_LONG
        DECFSZ  LOOP3, F       ;  3 
        GOTO    t23
        bcf     PORTA, HA
        bsf     FLAG2, 4       ;   3
        GOTO    m78            ;   
m56:
        BTFSS   PORTB, hand    ;  ?
        GOTO    m10
        bcf     FLAG2, 4        ;   3
        GOTO    m10 
m57:
        DECFSZ  r4sne, F        ;  r4sne
        GOTO    m10             ;   
        MOVLW	D'11'            ;    
	MOVWF	r4sne           ;   r4sne
m78: 
        bcf     FLAG1, 1        ;    2
        bcf     FLAG1, 2       ;    1
        GOTO    m10
m13: 
        bcf     PORTA, HA      ;  
        BTFSC   FLAG3, 3       ;    ?
        GOTO    m11
        DECFSZ  r4sne, F       ;  r4sne
        GOTO    m10            ;   
        MOVLW	D'11'           ;    
	MOVWF	r4sne          ;   r4sne 
        bcf     FLAG1, 2       ;    1
        
                      ;   
;------------------------------------------------------------------------------------
m10:
        BTFSC   FLAG1, 7       ;   ?
        GOTO    t12 
        BTFSS   FLAG1, 4       ;    ?
        GOTO    m14            ; ,   
m15:
        DECFSZ  r15m1, F     
        GOTO    m71
        MOVLW   D'140'
        MOVWF   r15m1
        DECFSZ  r15m2, F       ;  15 
        GOTO    m71   
        GOTO    m72     
m71:
        BTFSS   FLAG1, 3       ;   ?
        GOTO    m31            ;   
        bcf     FLAG1, 3       ;   
        movlw   .40
        MOVWF   LOOP3
t24:
        CALL    DELAY_LONG
        DECFSZ  LOOP3, F       ;  10 
        GOTO    t24
m72:
        CLRF    M_STOP
        bsf     M_STOP, 1      ;     
        GOTO    m16
m14:
        BTFSC   FLAG1, 6        ;   ?
        GOTO    m18             ; ,   
        BTFSC   FLAG1, 5        ;   ?
        GOTO    m19             ; ,   
m22:
        
        BTFSC   THM, 7          ;  ?
        GOTO    m31             ; ,   
        BTFSS   PORTB, torm     ;  HE 
        GOTO    m31             ; ,   
        BTFSC   PORTB, hand     ; ,   ?
        GOTO    m31             ; ,   
        BTFSC   PORTB, kanal    ;  ?
        GOTO    m20             ; ,   
        CALL    Delay_z         ;    
        BTFSC   PORTB, kanal    ;    ?
        GOTO    m20             ; ,   
        bsf     FLAG3, 2        ;   
        BTFSS   PORTB, key      ;   ?
        GOTO    m31             ;   
        BTFSS   PORTB, nakal    ;   ?
        GOTO    m31             ; ,   
m20:
        BTFSC   vibor, 0        ;  ?
        GOTO    m17             ; ,   
        BTFSS   FLAG2, 4        ;  3 ?
        GOTO    m79             ; ,   
m17:        
        BTFSC   FLAG3, 2        ;  / ?
        GOTO    m24             ; ,   
        BTFSS   SEL, 6          ;  SEL ?
        GOTO    m31             ; ,   
        BTFSC   PORTB, hand     ; ,   ?
        GOTO    m31             ; ,   
        BTFSS   FLAG2, 7        ;    1?
        GOTO    m31             ; ,   
        MOVF    TIME, F         ;  TIME ? 
        BTFSC   STATUS, Z
        GOTO    m23             ; ,    
        DECFSZ  rt1, F          ;   
        GOTO    m31
        MOVLW   D'200'
        MOVWF   rt1
        DECFSZ  rt2, F
        GOTO    m31
        MOVLW	D'60'     	;    
	MOVWF	rt2             ;   rt2
        DECF    TIME, F         ;   TIME
        GOTO    m31             ;     
m23:
        bcf     FLAG2, 4        ;   3
        bcf     FLAG2, 7        ;    1
m24:
        bcf     FLAG3, 2        ;   
        BTFSS   PORTB, door     ;  ?
        GOTO    m31             ; ,   
        bsf     FLAG1, 5        ; ,   
m25: 
        MOVLW   b'00001001'
        MOVWF   PORTA 
m19:
        DECFSZ  r6s, F          ;   6  . 
        GOTO    m31
        MOVLW	D'22'     	;    
	MOVWF	r6s             ;   r6s
        BTFSC   vibor, 1        ;  ?
        GOTO    m26             ; ,    
m27:
        bcf     FLAG4, 7        ;   
        bsf     FLAG1, 6        ;   
        MOVLW   b'00001010'
        MOVWF   PORTA 
m18: 
        DECFSZ  r6s, F          ;  6   
        GOTO    m28
        MOVLW	D'22'           ;  
        MOVWF	r6s             ;   r6s
m41:
        DECFSZ  attempt, F
        GOTO    m30
        MOVLW   h'03'           ;   
        MOVWF   attempt         ;  
m75:
        CLRF    M_STOP
        bsf     M_STOP, 2       ;   
m16:
        CALL    OFF             ;    
        GOTO    m31             ;    
m30:
        bcf     FLAG1, 6        ;   
        bsf     FLAG1, 7        ;   
t12:
        clrf    PORTA           ;  
        DECFSZ   r15s, F
        GOTO    t11        
        movlw   D'29'           ;    
        movwf   r15s
        bcf     FLAG1, 7        ;   
        GOTO    m25             ;   
m26:
        BTFSC   PORTB, nakal    ;   ?
        GOTO    m27             ; ,   
        BTFSS   FLAG4, 7        ;   ?
        GOTO    m82             ;   
        bcf     FLAG4, 7        ;   
        GOTO    m41             ;   
m82:
        bsf     FLAG4, 7        ;   
        GOTO    m19             ;   
m28:
        BTFSS   THM, 7          ;  ?
        GOTO    m31             ; ,    
        MOVLW   b'00001001'
        MOVWF   PORTA           ;    
        bsf     FLAG1, 4        ;    
        GOTO    m15             ;    
t11:
        call    DELAY_LONG      ;      
        GOTO    m31             ;    
m79:
        bcf     FLAG3, 2        ;   /
        GOTO    m31             ;    

                        ;  -
;---------------------------------------------------------------------------------
m31:
        BTFSS   THM, 7          ;   ?
        GOTO    m34             ; ,   
        BTFSC   PORTB, hand     ;  ?
        GOTO    m34             ;    
        BTFSC   PORTB, door     ;  ?
        GOTO    m34             ; ,   
        BTFSC   PORTB, torm
        GOTO    m34             ; ,   
        BTFSC   PORTB, key      ; ,   ?
        GOTO    m32             ; ,   
        CALL    Delay_z         ;    
        BTFSC   PORTB, key      ;    ?
        GOTO    m32             ; ,   
        bsf     FLAG2, 0        ; ,    -
        bsf     PORTA, HA       ;  
        GOTO    m33
m32:
        bcf     PORTA, HA       ;  
        BTFSS   FLAG2, 0        ;   - ?
        GOTO    m34             ; ,   
        bsf     FLAG3, 7        ;   -
        bsf     FLAG3, 4        ;   -1
        bsf     PORTA, ZG       ;  
        bsf     PORTA, GBR      ;   
        bcf     FLAG2, 3        ;    
        bcf     FLAG2, 0        ;    -
m35:
        bsf     PORTA, HA       ;  
        call    DELAY_LONG
        bcf     PORTA, HA       ;  
        GOTO    m33             ;   
m34:
        BTFSS   FLAG3, 7        ;  - ?
        GOTO    m33             ; ,   
        BTFSS   THM, 7          ;   ?
        GOTO    m81             ; ,   
        BTFSC   PORTB, hand     ;  ?
        GOTO    m81             
        DECFSZ  r60s, F         ;  60 
        GOTO    m54             ;   
m81:
        bcf     FLAG3, 7        ;   -
        MOVLW   D'97'           ;   
        MOVWF   r60s            ;  

                        ;    
;----------------------------------------------------------------------------
m33:
        BTFSS   FLAG1, 4        ;    ?
        GOTO    m70             ; ,   
m29:
        BTFSS   THM, 7          ;  ?
        GOTO    m77             ; ,   
        BTFSS   PORTB, kanal    ; ,    \ ?
        GOTO    m21             ; ,    
m58:
        BTFSC   PORTB, Pr       ;  ?
        GOTO    m40             ; ,     
        DECFSZ  minP, F         ;  30 .  
        GOTO    m39             ; ,    
        MOVLW	D'71'   	;    
	MOVWF	minP            ;   minP
        CLRF    M_STOP
        bsf     M_STOP, 3       ;   
        CALL    OFF
        GOTO    m37             ;   
m21:
        CALL    Delay_z         ;    
        BTFSC   PORTB, kanal    ;   \ ?
        GOTO    m58             ;   
        CLRF    M_STOP
        bsf     M_STOP, 4       ;   
        CALL    OFF 
        GOTO    m37             ;    
m40:
        MOVLW	D'71'   	;    
	MOVWF	minP            ;   minP
m39:
        BTFSC   FLAG3, 7        ;  - ?
        GOTO    m37             ;    
        BTFSC   PORTB, torm     ;   ?
        GOTO    m42             ; ,    
        CALL    Delay_z         ;    
        BTFSC   PORTB, torm     ;     ?
        GOTO    m42
        CLRF    M_STOP
        bsf     M_STOP, 5        ;    
        CALL    OFF
        GOTO    m37             ; ,     
m42:
        BTFSS   PORTB, hand     ;  ?
        GOTO    m43             ; ,   
        CALL    Delay_z         ; ,    
        BTFSS   PORTB, hand     ;    ?
        GOTO    m43
        CLRF    M_STOP
        bsf     M_STOP, 5       ;    
        CALL    OFF
        GOTO    m37             ; ,   
m43:
        BTFSC   PORTB, alarm    ;  
        GOTO    m44             ; ,   
        DECFSZ  r5s, F          ;  5 . 
        GOTO    m45             ;   
        MOVLW	D'12'   	;    
	MOVWF	r5s             ;   r5s
        CLRF    M_STOP
        bsf     M_STOP, 6       ;    
        CALL    OFF
        GOTO    m37             ;   
m70:
        BTFSS   FLAG3, 4        ;  -1 ?
        GOTO    m37
        GOTO    m29
m77: 
        bcf     FLAG3, 4        ;   -1
        CLRF    M_STOP
        bsf     M_STOP, 2       ;   
        CALL    OFF             ;    
        GOTO    m37
m44:
        MOVLW	D'12'   	;    
	MOVWF	r5s             ;   r5s
m45:
        BTFSC   PORTB, door     ;  ?
        GOTO    m46             ; ,   
        CALL    Delay_z         ;    
        BTFSC   PORTB, door     ;    ?
        GOTO    m46             ;   
        bsf     FLAG2, 3        ;    
        GOTO    m37             ;   
m46:
        BTFSS   FLAG2, 3        ;    ?
        GOTO    m37             ; ,   
        bcf     FLAG2, 3        ;   . 
        bsf     FLAG3, 1        ;    
        CLRF    M_STOP
        bsf     M_STOP, 5       ;    
        CALL    OFF             ;    
        
                      ;  EEPROM  
;-----------------------------------------------------------------------------------------
m37:
        BTFSC   FLAG2, 1        ;    ?
        GOTO    m47             ; ,   
        BTFSC   FLAG3, 5        ;    ?
        GOTO    m55
        MOVF    PORTB, W        ;      W
        XORLW   b'00001111'     ;     EEPROM ?
        BTFSS   STATUS, Z
        GOTO    m38             ; ,   
        bsf     FLAG2, 2        ;   
        DECFSZ  r10s, F         ;   10 .  
        GOTO    m59             ;   
        bsf     FLAG3, 5        ;    
        CLRF    vibor 
        bsf     PORTA, GBR      ;   
        bsf     PORTA, HA       ;  
        call    DELAY_LONG      ;  
        bcf     PORTA, HA       ;  
        GOTO    m52             ;   
m38:
        BTFSS   FLAG2, 2        ;    ?
        GOTO    m59             ; ,    
        GOTO    m52             ;   
m47:
        BTFSC   PORTB, key      ;  ?
        GOTO    m48             ; ,    
        CALL    Delay_z         ;    
        BTFSC   PORTB, key      ;  ?
        GOTO    m48             ; ,    
        bsf     FLAG3, 6        ;    
        bsf     PORTA, HA       ;  
        MOVLW	D'10'           ;    
	MOVWF	r3s             ;   r3s
        GOTO    m59             ;   
m48:
        bcf     PORTA, HA       ;  
        BTFSS   FLAG3, 6        ;    ?
        GOTO    m49             ; ,   
        bcf     FLAG3, 6        ; ,    
        INCF    vibor, F        ;   vibor
        MOVF    vibor, W        ;  vibor  W 
        SUBLW   D'4'            ;  vibor  4?
        BTFSS   STATUS, Z
        GOTO    m49             ; ,   
        CLRF    vibor 
m51:
        bcf     FLAG2, 1        ;    
        bcf     FLAG3, 5        ;    
        bcf     PORTA, GBR      ;   
        GOTO    MAIN1
m49:
        DECFSZ  r3s, F          ;  3 .  
        GOTO    m59           ;   

                            ;    EEPROM
;***************************************************************************************
        movf   vibor, W         ;   vibor  EEDATA
        movwf  EEDATA
        clrw                    ;   h'00'
        movwf  EEADR
        CALL   M_WR
                          ;   
WR_WAIT:
        btfss  EECON1, EEIF     ;    
        goto   WR_WAIT          ;   
                          ;  
        bcf    EECON1, EEIF     ;    
        bcf    STATUS, RP0      ;  0
        MOVF    vibor, W
        MOVWF   vibsig          ;  vibor  vibsig
        INCF    vibsig, F       ;  vibsig
m50:
        bsf     PORTA, HA       ;  
        call    DELAY_LONG
        bcf     PORTA, HA       ;  
        DECFSZ  vibsig, F      
        GOTO    m53
        GOTO    m51             ;   
m52:
        bcf     FLAG2, 2        ;    
        MOVLW   D'25'           ;    
        MOVWF   r10s
        GOTO    m59             ;   
m53: 
        call    DELAY_LONG  
        GOTO    m50             ;   
m54:
        BTFSC   PORTB, door     ;  ?
        GOTO    m33             ; ,   
        GOTO    m35             ; ,   
m55:
        BTFSS   PORTB, key      ;   ?
        GOTO    m59             ; ,    
        CALL    Delay_z         ;    
        BTFSS   PORTB, key      ;   ?
        GOTO    m59             ; ,    
        bsf     FLAG2, 1        ;    
   
                       ;    
;------------------------------------------------------------------------------------
m59:
        BTFSC   THM, 7          ;  ?
        GOTO    t1              ; ,   
        BTFSC   PORTB, torm     ;   ?
        GOTO    t1              ; ,   
        BTFSC   PORTB, Pr       ;  ?
        GOTO    t1              ; ,   
        BTFSC   PORTB, key      ;  ?
        GOTO    m67             ; ,   
        DECFSZ  r4stop, F
        GOTO    t1
        MOVLW   D'16'           ;   
        MOVWF   r4stop          ;  
        BTFSC   M_STOP, 6
        GOTO    m60
        BTFSC   M_STOP, 5
        GOTO    m65
        BTFSC   M_STOP, 4
        GOTO    m62
        BTFSC   M_STOP, 3
        GOTO    m63
        BTFSC   M_STOP, 2
        GOTO    m64
        BTFSC   M_STOP, 1
        GOTO    m61
        GOTO    t1
m67:
        MOVLW   D'16'           ;   
        MOVWF   r4stop          ;           
        GOTO    t1
m60:
        movlw   D'6'
        GOTO    m66
m61:
        movlw   D'1'
        GOTO    m66
m62:
        movlw   D'4'
        GOTO    m66
m63:
        movlw   D'3'
        GOTO    m66
m64:
        movlw   D'2'
        GOTO    m66
m65:
        movlw   D'5'
m66:
        movwf   M_SIG
m69:
        bsf     PORTA, HA       ;  
        call    DELAY_LONG
        bcf     PORTA, HA       ;  
        DECFSZ  M_SIG, F 
        GOTO    m68
        GOTO    CYCLE
m68:    
        call    DELAY_LONG       
        GOTO    m69 


                            ;    
;---------------------------------------------------------------------------------
t2:
        movlw   D'26'
        movwf   r10stmp
        GOTO    t0                  
t1:
        BTFSS   PORTB, nakal    ;   ?
        GOTO    m80             ; ,   
        BTFSS   THM, 7          ;  ?
        GOTO    m80      
        BTFSC   PORTB, torm     ;   ?
        GOTO    t0              ; ,   
        BTFSS   PORTB, door     ;  ?
        GOTO    t0              ; ,   
        BTFSC   PORTB, key      ;  ?
        GOTO    t2              ; ,   
        DECFSZ  r10stmp, F
        GOTO    t0
        movlw   D'26'
        movwf    r10stmp
        CALL 	CONFIG_DEVICE   ;   
        CALL 	START_CONVERT   ;   
        CALL 	READ_TEMP       ;  
        MOVWF 	T_C             ;     _
        CALL 	STOP_CONVERT    ;    
	btfsc	T_C,7		;   
	goto	m80   		;   ,   
        CALL    WRITE_T         ;    EEPROM 
        bsf     PORTA, 2
        movlw   4
        MOVWF   LOOP3
t3:
        CALL    DELAY_LONG
        DECFSZ  LOOP3, F
        GOTO    t3
        bcf     PORTA, 2
        GOTO    MAIN1
t0:
        CALL 	CONFIG_DEVICE   ;   
        CALL 	START_CONVERT   ;    
        CALL 	READ_TEMP       ;   
        MOVWF 	T_C             ;     _
        CALL 	STOP_CONVERT    ;   
	btfsc	T_C,7		;   
	goto	m80     	;   ,   
        MOVF    T_C, W
        SUBWF   KONTROL, W      ;  
        BTFSS   STATUS, C
        GOTO    t5
        bcf     FLAG1, 3        ;  
        GOTO    m80   
t5:
        bsf     FLAG1, 3        ;  
        
                         ;  
;-------------------------------------------------------------------------------
m80:
        BTFSS   FLAG3, 1        ;   ? 
        GOTO    CYCLE           ; ,   
        BTFSS   SEL, 7         ;  SEL ? 
        GOTO    CYCLE          ; ,   
        movlw   .12
        MOVWF   LOOP3
t33:
        CALL    DELAY_LONG
        DECFSZ  LOOP3, F        ;  3 
        GOTO    t33
        bsf     PORTA, HA       ;  
        call    DELAY_LONG      ;  
        call    DELAY_LONG
        bcf     PORTA, HA       ;  
        bcf     FLAG3, 1        ;   
        GOTO    CYCLE           ;    

                       ;    EEPROM
WRITE_T:
        bcf    STATUS, RP0      ;  0
        movf   T_C, W
        movwf  EEDATA
        movlw  h'01'                  ;   h'01'
        movwf  EEADR
        CALL   M_WR
                          ;   
WR_WAIT1:
        btfss  EECON1, EEIF     ;    
        goto   WR_WAIT1          ;   
                          ;  
        bcf    EECON1, EEIF     ;    
        bcf    STATUS, RP0      ;  0
        RETURN


;----------------------------------------
CONFIG_DEVICE:
        CALL 	INIT
        MOVLW 	0CH
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        MOVLW 	03H             ;  ,   1
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        MOVLW 	.20             ;  20    
        MOVWF 	LOOP1
        CALL 	DELAY_N_MS
        RETURN

;---------------------------------------

START_CONVERT:
        CALL 	INIT
        MOVLW 	0EEH
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        MOVLW 	.100            ;  100 
        MOVWF 	LOOP1
        CALL 	DELAY_N_MS
        RETURN

;---------------------------------------
READ_TEMP:
        CALL 	INIT
        MOVLW 	0AAH
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        CALL 	IN_BYTE
        MOVF 	I_BYTE, W
        RETURN

;---------------------------------------
STOP_CONVERT:
        CALL 	INIT
        MOVLW 	22H
        MOVWF 	O_BYTE
        CALL 	OUT_BYTE
        RETURN


;-------------------------------------------
;     1-Wire
;-------------------------------------------
INIT:
        CALL    PIN_HI
        CALL    PIN_LO
        MOVLW   .50              ;  500 
        CALL 	DELAY_10USEC
        CALL    PIN_HI
        MOVLW   .50              ;  500 
        CALL 	DELAY_10USEC
        RETURN

;-------------------------------------------
WAIT:
        CALL    IN_BYTE
        MOVLW   0FFH
        SUBWF   I_BYTE, W
        BTFSS   STATUS, Z
        GOTO    WAIT
        RETURN

;-------------------------------------------
IN_BYTE:              		;    W 
        MOVLW   .8
        MOVWF    _N
        CLRF    I_BYTE
IN_BYTE_1:
        CALL 	PIN_LO
        NOP
        CALL 	PIN_HI
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        MOVF    PORTB, W        ; 7 usecs later, fetch from DATA_PIN
        MOVWF   TEMP
        BTFSS   TEMP, DATA_PIN
        BCF 	STATUS, C       ; its a zero
        BTFSC   TEMP, DATA_PIN
        BSF 	STATUS, C       ; its a one
        RRF     I_BYTE, F
        MOVLW 	.6              ; now delay 60 usecs
        CALL    DELAY_10USEC
        DECFSZ  _N, F
        GOTO    IN_BYTE_1
        MOVFW   I_BYTE          ; return the result in W
        RETURN


;------------------------------------------
OUT_BYTE:
        MOVLW   .8
        MOVWF   _N
OUT_BYTE_1:
        RRF     O_BYTE, F
        BTFSS   STATUS, C
        GOTO    OUT_0
        GOTO    OUT_1
OUT_BYTE_2:
        DECFSZ  _N, F
        GOTO    OUT_BYTE_1
        RETURN

;-------------------------------------------
OUT_0:
        CALL    PIN_LO          ; bring DATA_PIN low
        MOVLW   .6              ; for 60 usecs
        CALL    DELAY_10USEC
        CALL    PIN_HI
        GOTO    OUT_BYTE_2
OUT_1:
        CALL    PIN_LO          ; momentary low
        CALL    PIN_HI
        MOVLW 	.6
        CALL 	DELAY_10USEC
        GOTO    OUT_BYTE_2

;-----------------------------------------

PIN_HI:
        BSF     STATUS, RP0
        BSF     TRISB, DATA_PIN ; high impedance
        BCF     STATUS, RP0
        RETURN
;---------------------------------------
PIN_LO:
        BCF     PORTB, DATA_PIN
        BSF     STATUS, RP0
        BCF     TRISB, DATA_PIN    ; low impedance zero
        BCF     STATUS, RP0
        RETURN
;---------------------------------------
DELAY_LONG
        MOVLW 	.250      ;  250 
        MOVWF 	LOOP1
DELAY_N_MS:
OUTTER:
        MOVLW   .110      ;  1 
        MOVWF   LOOP2
INNER:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ  LOOP2, F
        GOTO 	INNER
        DECFSZ  LOOP1, F
        GOTO 	OUTTER
        RETURN
;---------------------------------------
DELAY_10USEC:   	;   W * 10 
        MOVWF 	LOOP1
DELAY_10USEC_1:
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        NOP
        DECFSZ 	LOOP1, F
        GOTO 	DELAY_10USEC_1
        RETURN
;----------------------------------------------------------------------------------
                     ;     
Delay_z:
	MOVLW 	.49      ;  49 
        MOVWF 	LOOP1
        CALL    DELAY_N_MS
        MOVLW   .90
        CALL    DELAY_10USEC       ;  900 
        nop
        nop
        return
;-----------------------------------------------------------------------------------
OFF:                    ;   
        bcf     PORTA, ST       ;  
        call    DELAY_LONG      ; 
        bcf     PORTA, GBR      ;  
        call    DELAY_LONG
        call    DELAY_LONG
        bcf     PORTA, ZG       ;  
        bcf     FLAG1, 5        ;   , 
        bcf     FLAG1, 6        ; ,
        bcf     FLAG2, 4        ;   3
        bcf     FLAG1, 4        ;   
        MOVLW	D'22'           ;  
        MOVWF	r6s             ;   r6s
        MOVLW	D'140'          ;    
	MOVWF	r15m1           ;   r15m1
        MOVLW	D'15'           ;    
	MOVWF	r15m2           ;   r15m2
        return
READ_M:
       movwf  EEADR
       bsf    STATUS, RP0       ;  1
       bsf    EECON1, RD        ; 
       bcf    STATUS, RP0       ;  0
       movf   EEDATA, W         ;     W
       return
M_WR:
       bsf    STATUS, RP0      ;  1
       bsf    EECON1, WREN     ;    EEPROM
                          ;   
       movlw  55h
       movwf  EECON2
       movlw  h'AA'
       movwf  EECON2
       bsf    EECON1, WR       ;    
       return
        End
          
          
